config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: {
     sessions: 'public/sessions',
     registrations: 'public/registrations'
  }
  scope module: :public do
    get 'users/confirm', to: 'users#confirm'
    get 'users/withdraw', to: 'users#withdraw'
    get 'works/my_works', to: 'works#my_works'
    get 'works/:id/self_work_entries', to: 'works#my_work_entries', as: 'self_work_entries'
    get 'favorites', to: 'favorites#index'
    get 'book_marks', to: 'book_marks#index'
    post 'entries/scout', to: 'entries#scout'
    resources :entries, only: [:show, :create, :index, :update]
    resources :portfolios, only: [:new, :create, :edit, :destroy, :update]
    resources :users, only: [:show, :edit, :update, :destroy, :index]
    resources :messages, only: [:create]
    resources :rooms, only: [:show, :index]
    resources :employer_evaluations, only: [:create]
    resources :labor_evaluations, only: [:create]
    resources :posts, only: [:show, :create, :destroy, :index] do
      resource :favorites, only: [:create, :destroy, :index]
    end
    resources :works do
      resource :book_marks, only: [:create, :destroy]
    end
  end

  devise_for :admin, :controllers => {
     sessions: 'admin/sessions',
  }

  root 'home#top'
  get 'about', to: 'home#about'
  get 'contact', to: 'home#contact'
end

app/models/admin.rb
class Admin < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/book_mark.rb
class BookMark < ApplicationRecord
  belongs_to :user
  belongs_to :work
end

app/models/category.rb
class Category < ApplicationRecord
  has_many :posts
end

app/models/employer_evaluation.rb
class EmployerEvaluation < ApplicationRecord
  belongs_to :user
  belongs_to :entry

  validates :evaluation, numericality: { less_than_or_equal_to: 5 }
end

app/models/entry.rb
class Entry < ApplicationRecord
  belongs_to :user
  belongs_to :work
  has_one :room
  has_one :employer_evaluation
  has_one :labor_evaluation
  enum working_status: { unsettled: 0, confirmed: 1, completed: 2 }
end

app/models/favorite.rb
class Favorite < ApplicationRecord
  belongs_to :user
  belongs_to :post
end

app/models/labor_evaluation.rb
class LaborEvaluation < ApplicationRecord
  belongs_to :user
  belongs_to :entry

  validates :evaluation, numericality: { less_than_or_equal_to: 5 }
end

app/models/message.rb
class Message < ApplicationRecord
  belongs_to :user
  belongs_to :room

  validates :message, presence: true

  def set_date
    created_at.strftime("%m月%d日%H時%M分")
  end

  def short_description
    description[0, 100] + '...'
  end
end

app/models/portfolio.rb
class Portfolio < ApplicationRecord
  validates :title, presence: true
  validates :description, presence: true
  belongs_to :user
end

app/models/post.rb
class Post < ApplicationRecord
  acts_as_paranoid
  attachment :image, destroy: false
  has_many :favorites
  belongs_to :user
  belongs_to :category, optional: true

  validates :title, presence: true, length: { maximum: 50 }
  validates :content, presence: true
  

  def favorited_by?(user)
    favorites.where(user_id: user.id).exists?
  end
end

app/models/room.rb
class Room < ApplicationRecord
  has_many :messages
  belongs_to :entry
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  attachment :profile_image
  acts_as_paranoid
  validates :introduction, length: { maximum: 1000 }
  validates :display_name , presence: true
  validates :name , presence: true

  has_many :favorites, dependent: :destroy
  has_many :posts, dependent: :destroy
  has_many :works
  has_many :book_marks, dependent: :destroy
  has_many :entries
  has_many :messages
  has_many :portfolios, dependent: :destroy
  has_many :employer_evaluations
  has_many :labor_evaluations

  enum status: { personal: 0, company: 1 }

  ##住所検索
  include JpPrefecture
  jp_prefecture :prefecture_code

  def prefecture_name
    JpPrefecture::Prefecture.find(code: prefecture_code).try(:name)
  end

  def prefecture_name=(prefecture_name)
    self.prefecture_code = JpPrefecture::Prefecture.find(name: prefecture_name).code
  end

  def check_entry(work)
    Entry.find_by(work_id: work.id, user_id: self.id)
  end
end

app/models/work.rb
class Work < ApplicationRecord
  acts_as_paranoid
  attachment :image, destroy: false
  has_many :book_marks
  has_many :entries
  belongs_to :user
  belongs_to :category, optional: true

  enum recruitment_status: { recruiting: 0,
                             recruitment_suspended: 1,
                              end_recruitment: 2 }

  validates :title, presence: true
  validates :description, presence: true
  validates :condition, presence: true
  validates :started_at, presence: true
  validates :ended_at, presence: true
  validates :reward, presence: true
  

  ##住所検索
  include JpPrefecture
  jp_prefecture :prefecture_code

  def prefecture_name
    JpPrefecture::Prefecture.find(code: prefecture_code).try(:name)
  end

  def prefecture_name=(prefecture_name)
    self.prefecture_code = JpPrefecture::Prefecture.find(name: prefecture_name).code
  end

  def book_marked_by?(user)
    book_marks.where(user_id: user.id).exists?
  end
end

app/controllers/Admin/posts_controller.rb
class Admin::PostsController < ApplicationController
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :configure_permitted_parameters, if: :devise_controller?
  
  protected
  
  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:attribute, :name, :introduction, :profile_image, :display_name, :email,
                                      :birth_date, :phone_number, :status, :postal_code, :prefecture_code, :prefecture_name, :address_city, :address_street, :address_building])
  end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def top
  end

  def about
  end

  def contact
  end
end

app/helpers/admin/posts_helper.rb
module Admin::PostsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
  
end

app/helpers/home_helper.rb
module HomeHelper
end

app/views/layouts/_errors.html.erb
<% if obj.errors.any? %>
    <div id="error_explanation">
      <h3><%= pluralize(obj.errors.count, "件のエラーがみつかりました") %> </h3>

      <ul>
      <% obj.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Ichigei</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all' %>
    <%= javascript_include_tag 'application' %>
  </head>

  <body>
    <header>
      <div class="header-content clearfix">
        <div class="logo">
          <%= link_to 'Ichigei', root_path %>
        </div>
        <nav class='header-nav'>
          <% if current_user %>
            <ul class="nav-list clearfix">
              <li><%= link_to 'トップページへ', root_path %></li>
              <li><%= link_to 'マイページ', user_path(current_user) %></li>
              <li><%= link_to 'みんなの投稿', posts_path %></li>
              <li><%= link_to '仕事を探す', works_path %></li>
              <li><%= link_to 'ログアウト', destroy_user_session_path, method: :delete %></li>
            </ul>
          <% elsif current_admin %>
            <ul class="nav-list">
              <li><%= link_to 'トップページへ', root_path %></li>
              <li><%= link_to 'ログアウト', destroy_admin_session_path, method: :delete %></li>
            </ul>
          <% else %>
            <ul class="nav-list">
              <li><%= link_to 'トップページへ', root_path %></li>
              <li><%= link_to 'ログイン', new_user_session_path %></li>
              <li><%= link_to '会員登録', new_user_registration_path %></li>
            </ul>
          <% end %>
        </nav>
      </div>
    </header>
    <main>
      <div class="container">
        <%= yield %>
      </div>
    </main>
    <footer>
      <div class="footer-content clearfix">
        <div class="footer-left">
          <h2 class="footer-title">
            <%= link_to 'Ichigei', root_path %>
          </h2>
        </div>
        <div class="footer footer-right">
          <p><%= link_to 'about', about_path %></p>
          <p><%= link_to 'contact', contact_path %></p>
          <p class="footer-p">©︎ 2020 K-Iwahista </p>
        </div>
      </div>
    </footer>
    <style>
  #map {
    height: 400px;
  }
</style>

  <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAcm7-xTp39IUeIVNJoju8dAmUEDpJqJmo&callback=initMap" async defer></script>
  </body>
</html>

app/views/shared/_error_messages.html.erb
<% if flash[:error_messages] %>
  <h3>エラー</h3>
  <div class="alert alert-danger">
    <ul>
      <%= flash[:error_messages]%>
      <% flash.each do |message_type, msg| %>
        <li><%= msg %></li>
      <% end %>
    </ul>
  </div>
<% end %>

app/views/shared/_left_field.html.erb
<div class="left-field">
  <div class="links">
    <h3>Menu</h3>
    <div class="left-field-item">
      <%= link_to '仕事を作る', new_work_path%><br>
      <%= link_to 'メッセージ', rooms_path %>
      <%= link_to '募集した求人一覧', works_my_works_path %><br>
      <%= link_to 'お気に入りしたイチゲイ', favorites_path %>
      <%= link_to 'ブックマークした求人', book_marks_path	%><br>
      </div>
  </div>
  <div class="links">
    <h3>所持ポイント</h3>
    <div class="left-field-item">
      <p class="point-show"><%= current_user.point %>P</p>
    </div>
  </div>
  <%= render "shared/new_post_form", post: post %>
</div>

app/views/shared/_message_lists.html.erb
<h2>メッセージ</h2>
<% @room.messages.each do |msg| %>
  <% if msg.user == @room.entry.user && msg != nil %>
    <div class="applied_user_msg msg-list clearfix">
      <div class="user-show-link-r">
        <%= link_to(msg.user) do %>
            <%= attachment_image_tag(msg.user, :profile_image, :fill, 60, 60, format: 'jpeg' ) %><br>
            <p><%= msg.user.display_name %></p>
        <% end %>
      </div>
      <div class="msg-right">
        <div class='message-date-r'><p><%= msg.set_date %></p></div>
        <div class="message-content-r">
          <p><%= msg.message %></p>
        </div>
      </div>
    </div>
  <% else %>
    <div class="recruited_user_msg msg-list clearfix">
      <div class="user-show-link">
        <%= link_to(msg.user) do %>
            <%= attachment_image_tag(msg.user, :profile_image, :fill, 60, 60, format: 'jpeg' ) %>
            <p><%= msg.user.display_name %></p>
        <% end %>
      </div>
      <div class='message-date'><%= msg.set_date %></div>
      <div class="message-content">
        <p><%= msg.message %></p>
      </div>
    </div>
  <% end %>
<% end %>

app/views/shared/_new_post_form.html.erb
<div class="post_form">
  <h3>イチゲイを新規登録</h3>
  <%= render 'layouts/errors', obj: post %>
  <div class="left-field-item">
    <%= form_for(post, url: {controller: 'public/posts', action: 'create'}, method: :post) do |f| %>
      <div class="post-field">
        <%= f.label 'タイトル' %><br>
        <%= f.text_field :title, class: "", value: nil, :size=>"45" %>
      </div>
      <div class="post-field">
        <%= f.label '内容' %><br>
        <%= f.text_area :content, class: "", value: nil, :size=>"45x10" %>
      </div>
      <div class="post-field">
        <%= f.label '関連URL' %><br>
        <%= f.text_field :url, class: "", value: nil, :size=>"45" %>
      </div>
      <div class="post-field">
        <%= f.label "画像" %><br>
        <%= f.attachment_field :image %>
      </div>
      <div class="post-field">
        <%= f.label "イチゲイのジャンル" %><br>
        <%= f.collection_select :category, Category.all, :id, :name, {include_blank: '選択してください'} %>
      </div>
      <div class="">
        <%= f.submit "新たなイチゲイを投稿", method: :post, class: "btn btn-primary"  %>
      </div>
    <% end %>
  </div>
</div>

app/views/shared/_post_index_field.html.erb
<table class='table table-hover table-inverse'>
  <thead>
    <tr>
      <th></th>
      <th>Title</th>
      <th>URLリンク</th>
      <th>カテゴリー</th>
      <th>お気に入り</th>
      <th></th>
    </tr>
  </thead>
  <tbody class='post-table'> 
    <%= render 'shared/post_table', posts: posts %>
  </tbody>
</table>
<%= paginate posts %>

app/views/shared/_post_show.html.erb
<div class="right-field">
  <div class='right-field-title'>
    <h3>イチゲイ詳細</h3>
  </div>

  <div class="show-item">
    <h4 class="show-item-title"><%= post.title %></h4>
  </div>

  <div class="show-item">
    <h4 class="show-item-label">ユーザー</h4>
      <%= link_to(post.user) do %>
        <div class="show-item-content">
          <%= attachment_image_tag(post.user, :profile_image, :fill, 60, 60, format: 'jpeg' ) %>
          <p><%= post.user.display_name %></p>
        </div>
      <% end %>
  </div>

  <div class="show-item">
    <div class="show-item-label">
      <h4>イチゲイのカテゴリー</h4>
    </div>
    <div class="show-item-content">
      <% if post.category %>
        <p><%= post.category.name %></p>
      <% else %>
        <p>カテゴリー登録なし</p>
      <% end %>
    </div>
  </div>

  <div class="show-item">
    <h4 class="show-item-label">Accsess Link</h4>
    <div class="show-item-content">
      <p><%= link_to post.url, post.url %></p>
    </div>
  </div>

  <div class="show-item">
    <h4 class="show-item-label">Content</h4>
    <div class="show-item-content">
      <p><%= post.content %></p>
    </div>
  </div>

  <div class="show-item">
    <h4 class="show-item-label">画像</h4>
    <div class="show-item-content">
      <%= attachment_image_tag(post, :image, :fill, 500, 300, format: 'jpeg' ) %>
    </div>
  </div>

  <div class="show-item">
    <h4 class="show-item-label">URLリンク</h4>
    <div class="show-item-content">
      <%= post.url %>
    </div>
  </div>

  
  <% if current_user != post.user %>
    <div class="show-item">
      <div class="show-item-label">
        <h4>この投稿をしたユーザーを、あなたの求人にスカウト</h4>
      </div>
      <% if current_user.works != [] %>
        <div class="show-item-content">
          <%= form_tag(entries_scout_path) do  %>
            <p>以下からスカウトしたい求人を選択してください</p>
            <%= collection_select(:works, :id, current_user.works, :id, :title) %>
            <%= hidden_field_tag :user_id, post.user.id, placeholder: '選択してください' %><br>
            <%= hidden_field_tag :post_id, post.id, placeholder: '選択してください' %><br>
            <%= submit_tag 'この求人にスカウトする' %>
          <% end %>
        </div>
      <% else %>
        <div class="show-item-content">
          登録されている求人情報がありません。<br>
          <%= link_to '仕事を追加する', new_work_path, class: 'btn btn-primary'%>
        </div>
      <% end %>
    </div>
  <% end %>

</div>

app/views/shared/_post_table.html.erb
<% posts.each do |post| %>
  <tr class="table-item <%= 'table__item--' + post.id.to_s %>">
    <% if post != nil %>
      <td>
        <%= link_to(post.user) do %>
          <%= attachment_image_tag(post.user, :profile_image, :fill, 50, 50, fallback: "no-image-icon.jpg") %>
        <% end %>
      </td>      
      <td class="index-title-link">
        <%= link_to(post_path(post)) do %>
          <p>
            <%= post.title %>
          </p>
        <% end %>
      </td>
      <td><%= link_to post.url, post.url %></td>
      <% if post.category %>
        <td><%= post.category.name %></td>
      <% else %>
        <td>カテゴリーなし</td>
      <% end %>
      <td class=<%= "table__favorite--" + post.id.to_s %>>
        <%= render 'public/favorites/favorites', post: post, user: current_user %>
      </td>
      <% if post.user == current_user %>
        <td><%= link_to '削除する', post_path(post), method: :delete, remote: true, data: { confirm: '本当に消しますか？' } %></td>
      <% else %>
        <td></td>
      <% end %>
    <% end %>
  </tr>
<% end %>

app/views/shared/_right_field.html.erb
<div class="right-field">
  <%= render "shared/user_profile", user: user %>
  <h3>イチゲイ</h3>
  <% if user.posts.count != 0 %>
    <%= render "shared/post_index_field", user: user, posts: @user.posts.page(params[:page]).per(15).order(created_at: :desc)%>
  <% end %>
</div>

app/views/shared/_search_form.html.erb
<% if obj.class == Post %>
  <% path = posts_path%>
  <% title = 'タイトル'%>
  <% class_name = 'イチゲイ' %>
<% else %>
  <% path = works_path%>
  <% title = '仕事名' %>
  <% class_name = '仕事' %>
<% end %>

<div class='search-form'>
  <%= search_form_for(@q, url: path) do |f| %>
    <p><%= "名前で検索" %><br><%= f.search_field :title_cont, :size => "35" %></p>
    <p><%= "カテゴリー"%><br><%= f.collection_select :category_id_eq, Category.all, :id, :name, :include_blank => '指定なし' %></p>
    <% if obj.class == Work %>
      <p><%= '勤務地' %><br><%= f.collection_select :prefecture_code_eq, JpPrefecture::Prefecture.all, :code, :name, :include_blank => '指定なし' %></p>
    <% end %>
    <%= f.submit %>
  <% end %>
</div>

app/views/shared/_user_profile.html.erb
<div class='user-profile'>
  <h3 class="user-show-title">プロフィール
    <% if current_user == @user %>
      <%= link_to '編集', edit_user_path(current_user), method: :get %>
    <% end %>
  </h3>

  <div class="profile-content">
    <h4 class='profile-label'>名前</h4>
    <div class='profile-item user-show-name'>
      <%= attachment_image_tag(@user, :profile_image, :fill, 60, 60, fallback: "no-image-icon.jpg") %><p><%= user.display_name %></p>
    </div>
    <div class='profile-item user-show-item'><P>総合評価</P><p><%= @total_evaluation_ave %></p><P>(<%= @labor_evaluations.count + @employer_evaluations.count%>件)</P></div>
    <div class='profile-item user-show-item'><P>労働評価</P><p><%= @labor_evaluation_ave %></p><P>(<%= @labor_evaluations.count%>件)</P></div>
    <div class='profile-item user-show-item'><P>雇い評価</P><p><%= @employer_evaluation_ave %></p><P>(<%= @employer_evaluations.count%>件)</P></div>
  </div>
  
  <div class="profile-content">
    <h4 class='profile-label'>ユーザーの形式</h4>
    <div class='profile-item'><%= user.status_i18n %></div>
  </div>

  <div class="profile-content">
    <% if user.status_i18n == '個人' %>
      <h4 class='profile-label'>居住地</h4>
      <div class="profile-item">
        <%= user.prefecture_name %>
      </div>
      <% if @user == current_user %>
        <div class="profile-item">
          <div id="map">
          </div>
        </div>
      <% end %>
    <% else %>
      <h4 class='profile-label'>所在地 </h4>
      <div class="profile-item">
        <%= user.prefecture_name %><%= user.address_city %><%= user.address_street %><%= user.address_building %>
      </div>
      <div class="profile-item">
        <div id="map">
        </div>
      </div>
    <% end %>
  </div>

  <div class="profile-content">
    <h4 class='profile-label'>紹介文</h4>
    <div class='profile-item'><%= user.introduction %></div>
  </div>

  <div class="profile-content">
    <h4 class='profile-label'>ポートフォリオ
      <% if @user == current_user %>
         <%= link_to'追加', new_portfolio_path, class: 'portfolio-tsuika' %>
      <% end %>
    </h4>
    <% @user.portfolios.each do |portfolio| %>
      <div class="portfolio-content">
        <p class='profile-item'>
          <%= portfolio.title %>
          <% if @user == current_user %>
            <%= link_to'編集', edit_portfolio_path(portfolio), class: 'portfolio-tsuika'%>
            <%= link_to'削除', portfolio_path(portfolio), method: :delete, class: 'portfolio-tsuika'%>
          <% end %>
        </p>
        <p class='profile-item'>リンク：<%= link_to portfolio.link, portfolio.link %></p>
        <p class='profile-item'><%= portfolio.description %></p>
      </div>
    <% end %>
  </div>
  <div class="profile-content">
    <h4 class='profile-label'>ユーザーのリンク（twitter, github, Youtube等）</h4>
    <div class='profile-item'><%= link_to user.url_link, user.url_link %></div>
  </div>
</div>

<script>
  let map
  var geocoder

  function initMap() {
    geocoder = new google.maps.Geocoder();
    geocoder.geocode({
      address: "<%= @user.prefecture_name %><%= @user.address_city %><%= @user.address_street %>"
    }, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK) {
        map = new google.maps.Map(document.getElementById('map'), {
          center: results[0].geometry.location, // 地図の中心を指定
          zoom: 12 // 地図のズームを指定
        });
        marker = new google.maps.Marker({
          position: results[0].geometry.location, // マーカーを立てる位置を指定
          map: map // マーカーを立てる地図を指定
        });
      } else {
        map = new google.maps.Map(document.getElementById('map'), {
          center: {lat: 36, lng:135},
          zoom: 6
        });

        var marker = new google.maps.Marker({
          position: {lat: 36, lng:135},
          map: map
        });
      }
    });
  }
  </script>

app/views/shared/_work_entry_form.html.erb
<div class='entry-form'>
  <% if work.user == current_user %>
    <%= link_to 'この求人の応募者一覧', self_work_entries_path(work), method: :get %>
    <%= link_to 'この求人を編集する', edit_work_path(work)%>
  <% else %>
    <% if current_user.check_entry(work) == nil %>
      <%= link_to 'この求人に応募する', entries_path(work_id: work), method: :post, remote: true, data: { confirm: 'この求人に応募しますか？' } %>
    <% else %>
      <%= link_to "応募済みの求人です\r\nメッセージへ", room_path(entry.room), method: :get %>
    <% end %>
  <% end %>
</div>

app/views/shared/_work_table.html.erb
<table class='table table-hover table-inverse'>
  <thead>
    <tr>
      <th></th>
      <th>Title</th>
      <th>条件</th>
      <th>カテゴリー</th>
      <th>勤務地</th>
      <th>ブックマーク</th>
      <th></th>
    </tr>
  </thead>
  <tbody> 
    <% works.each do |work| %>
      <% if work != nil %>
        <tr class="table-item">
          <td>
            <%= link_to(work.user) do %>
              <%= attachment_image_tag(work.user, :profile_image, :fill, 50, 50, fallback: "no-image-icon.jpg") %>
            <% end %>
          </td>      
          <td><%= link_to work.title, work_path(work) %></td>
          <td><%= work.condition.truncate(20) %></td>
          <% if work.category %>
            <td><%= work.category.name %></td>
          <% else %>
            <td>カテゴリーなし</td>
          <% end %>
          <td><%= work.prefecture_name %></td>
          <td class=<%= "table__book_mark--" + work.id.to_s %>>
            <%= render 'public/book_marks/book_mark', work: work, user: current_user %>
          </td>
          <% if work.user == current_user %>
            <td><%= link_to '削除する', work_path(work), method: :delete %></td>
          <% else %>
            <td></td>
          <% end %>
        </tr>
      <% end %>
    <% end %>
  </tbody>
</table>